using System;
using System.Web;

namespace CSharpSample
{
	/// <summary>
	/// Summary description for Methods.
	/// </summary>
	public class DemoMethods
	{
		[Ajax.AjaxMethod]
		public static string Test1(string firstName, string familyName, string email, string comment)
		{
			return "Hello " + firstName + " " + familyName + "<br>Thank you for your comment (" + DateTime.Now.ToString() + "):<br><b>" + System.Web.HttpUtility.HtmlEncode(comment).Replace("\r", "<br>") + "</b>.";
		}

		[Ajax.AjaxMethod]
		public string Test2(DateTime d)
		{
			d = d.AddDays(1);

			return "The next day will be " + d.ToLongDateString() + ".";
		}

		[Ajax.AjaxMethod]
		public System.Data.DataSet Test3()
		{
			System.Data.DataSet ds = new System.Data.DataSet();

			System.Data.DataTable dt = new System.Data.DataTable();
			dt.Columns.Add("Country", typeof(System.String));

			ds.Tables.Add(dt);

			System.Data.DataRow row;
			
			// fill sample data (i.e. can be replaced with database query)
			
			row = ds.Tables[0].NewRow();
			row["Country"] = "Germany";
			dt.Rows.Add(row);

			row = ds.Tables[0].NewRow();
			row["Country"] = "Austria";
			dt.Rows.Add(row);

			row = ds.Tables[0].NewRow();
			row["Country"] = "Switzerland";
			dt.Rows.Add(row);

			row = ds.Tables[0].NewRow();
			row["Country"] = "France";
			dt.Rows.Add(row);

			row = ds.Tables[0].NewRow();
			row["Country"] = "Bavaria  ;)";
			dt.Rows.Add(row);


			return ds;
		}

		[Ajax.AjaxMethod]
		public void Test4()
		{
			throw new System.Security.SecurityException("This user does not have access rights on this resource.");
		}

		[Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)]
		public void Test5(string value)
		{
			HttpContext.Current.Session["test"] = value;
		}

		[Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.Read)]
		public string Test6()
		{
			if(HttpContext.Current.Session["test"] != null)
				return (string)HttpContext.Current.Session["test"];

			return "First set the value...";
		}
		

		[Ajax.AjaxMethod]
		public void Test7()
		{
			int c = 0;
			
			do
			{
				System.Threading.Thread.Sleep(1000);
				c++;
			}
			while(c < 10);
		}


		[Ajax.AjaxMethod]
		public int Test8()
		{
			Random r = new Random(System.DateTime.Now.Second);
			return r.Next(0, 100);
		}


		[Ajax.AjaxMethod]
		public System.Collections.Specialized.StringCollection Test9()
		{
			System.Collections.Specialized.StringCollection s = new System.Collections.Specialized.StringCollection();

			s.Add("Michael");
			s.Add("Hans");

			return s;
		}

		[Ajax.AjaxMethod]
		public object[] Test10()
		{
			object[] o = new object[3];

			o[0] = "Michael";
			o[1] = DateTime.Now;
			o[2] = true;

			return o;
		}

		[Ajax.AjaxMethod]
		public System.Collections.ArrayList Test11()
		{
			System.Collections.ArrayList a = new System.Collections.ArrayList();

			a.Add("Michael");
			a.Add(DateTime.Now);
			a.Add(true);

			Person p1 = new Person();
			p1.FirstName = "Michael";
			
			SpecialPerson p2 = new SpecialPerson();		// will be inherit from Person
			p2.FirstName = "Tanja";
			p2.Comment = "My comment for this person!";

			a.Add(p1);
			a.Add(p2);

			return a;
		}

		[Ajax.AjaxMethod]
		public Person Test12()
		{
			// Create your own class like you have done it before.
			// See Person class at end of this file!

			Person p = new Person();

			p.FirstName = "Michael";
			p.FamilyName = "Schwarz";
			p.Age = 28;

			Person mj = p.NewChild();

			mj.FirstName = "Marc Julain";
			mj.Age = 3;

			Person jo = p.NewChild();

			jo.FirstName = "Jan Oliver";
			jo.Age = 1;

			p.Children = new Person[2];

			p.Children[0] = mj;
			p.Children[1] = jo;

			// Return the object without any change on the source code.
			return p;
		}

		[Ajax.AjaxMethod]
		public NewsTicker Test13()
		{
			NewsTicker[] nt = new NewsTicker[10];

			#region Build some examples (will be stored in a database or xml file)

			nt[0] = new NewsTicker("Ajax.NET Library", "http://ajax.schwarz-interactive.de", 4);
			nt[1] = new NewsTicker("Google Search", "http://www.google.com", 2);
			nt[2] = new NewsTicker("It is now " + DateTime.Now.ToString(), "http://ajax.schwarz-interactive.de", 4);
			nt[3] = new NewsTicker("ASP.NET Weblogs", "http://weblogs.asp.net/mschwarz", 3);
			nt[4] = new NewsTicker("Free Ajax.NET Wrapper", "http://weblogs.asp.net/mschwarz", 4);
			nt[5] = new NewsTicker("New C# examples online!", "http://ajax.schwarz-interactive.de", 3);
			nt[6] = new NewsTicker("PC-Topp.NET Demo", "http://demo.pctopp.com", 2);
			nt[7] = new NewsTicker("NEW Ajax.NET Library", "http://ajax.schwarz-interactive.de", 4);
			nt[8] = new NewsTicker("Download ajax.dll", "http://ajax.schwarz-interactive.de", 2);
			nt[9] = new NewsTicker("Free Download!!", "http://ajax.schwarz-interactive.de", 2);

			#endregion

			Random r = new Random(System.DateTime.Now.Second);
			int i = r.Next(0, nt.Length -1);

			return nt[i];
		}

		[Ajax.AjaxMethod]
		public System.Data.DataSet Test15()
		{
			System.Data.SqlClient.SqlConnection conn = new System.Data.SqlClient.SqlConnection("server=(local);uid=??;password=????;Initial Catalog=Northwind;");

			System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand("SELECT TOP 10 * FROM Customers C INNER JOIN Orders O ON O.CustomerID = C.CustomerID", conn);
			
			System.Data.SqlClient.SqlDataAdapter da = new System.Data.SqlClient.SqlDataAdapter(cmd);

			System.Data.DataSet ds = new System.Data.DataSet();

			try
			{
				conn.Open();

				try
				{
					da.Fill(ds);
				}
				catch(Exception)
				{}
				finally
				{
					conn.Close();
					conn.Dispose();
				}
			}
			catch(Exception)
			{}

			return ds;
		}

		[Ajax.AjaxMethod]
		public System.Drawing.Bitmap Test16()
		{
			System.Drawing.Bitmap bmp = new System.Drawing.Bitmap(200, 50);
			System.Drawing.Graphics g = System.Drawing.Graphics.FromImage(bmp);
		
			g.FillRectangle(new System.Drawing.SolidBrush(System.Drawing.Color.Yellow), 0, 0, 199, 49);
			g.DrawString(DateTime.Now.ToString(), new System.Drawing.Font("Arial", 10), new System.Drawing.SolidBrush(System.Drawing.Color.Red), 10, 10);

			return bmp;
		}

		[Ajax.AjaxMethod]
		public int Test17(int[] i)
		{
			int r = 0;
			foreach(int ii in i)
				r += ii;

			return r;
		}

		[Ajax.AjaxMethod]
		public string Test18(string[] s)
		{
			string r = "";
			foreach(string ss in s)
				r += "<p>" + ss + "</p>\r\n";

			return r;
		}

		[Ajax.AjaxMethod]
		public System.Web.UI.HtmlControls.HtmlSelect Test19(string car)
		{
			System.Web.UI.HtmlControls.HtmlSelect control = new System.Web.UI.HtmlControls.HtmlSelect();

			switch(car)
			{
				case "VW":
					control.Items.Add("Golf");
					control.Items.Add("Passat");
					control.Items.Add("Beetle");
					control.Items.Add("Phaeton");
					break;

				case "Mercedes":
					control.Items.Add("S Class");
					control.Items.Add("E Class");
					control.Items.Add("A Class");
					control.Items.Add("M Class");
					break;

				case "Citroen":
					control.Items.Add("C3 Pluriel");
					control.Items.Add("C5 Break");
					control.Items.Add("C8");
					control.Items.Add("Berlingo");
					break;
			}

			return control;
		}

		[Ajax.AjaxMethod(30)]
		public System.DateTime Test20()
		{
			return DateTime.Now;
		}

		[Ajax.AjaxMethod]
		public System.Web.UI.HtmlControls.HtmlSelect Test21(System.Web.UI.HtmlControls.HtmlSelect select)
		{
			select.Items.Add("New option added at " + DateTime.Now);
			return select;
		}

		[Ajax.AjaxMethod]
		public System.Xml.XmlDocument Test22()
		{
			System.Xml.XmlDocument doc = new System.Xml.XmlDocument();
			doc.LoadXml("<ROOT/>");

			doc.DocumentElement.InnerText = DateTime.Now.ToString();

			return doc;
		}
	}






	[Serializable]
	public class NewsTicker
	{
		public Guid ID = Guid.NewGuid();

		public NewsTicker(string text, string url, int duration)
		{
			this.Text = text;
			this.URL = url;
			this.Duration = duration;
		}

		public string Text;
		public string URL;
		public int Duration = 60;
	}

	[Serializable]
	public class Person // : System.Collections.CollectionBase
	{
		public string FirstName;
		public string FamilyName;
		public int Age = 0;
		public decimal Money = 200.5m; 

		public Person NewChild()
		{
			Person p = new Person();

			p.FamilyName = FamilyName;

			return p;
		}

		public Person[] Children = null;

		#region CollectionBase Methods

//		public Person this[ int index ]  
//		{
//			get{ return ((Person)List[index]); }
//			set{ List[index] = value; }
//		}
//
//		public int Add(Person value)
//		{
//			return(List.Add(value));
//		}
//
//		public int IndexOf(Person value)  
//		{
//			return(List.IndexOf(value));
//		}
//
//		public void Insert(int index, Person value)  
//		{
//			List.Insert(index, value);
//		}
//
//		public void Remove(Person value)  
//		{
//			List.Remove(value);
//		}
//
//		public bool Contains(Person value)  
//		{
//			// If value is not of type Int16, this will return false.
//			return(List.Contains(value));
//		}
//
//		protected override void OnInsert(int index, Object value)  
//		{
//			if(value.GetType() != Type.GetType("CSharpSample.Person"))
//				throw new ArgumentException("value must be of type CSharpSample.Person.", "value");
//		}
//
//		protected override void OnRemove(int index, Object value)  
//		{
//			if(value.GetType() != Type.GetType("CSharpSample.Person"))
//				throw new ArgumentException("value must be of type CSharpSample.Person.", "value");
//		}
//
//		protected override void OnSet(int index, Object oldValue, Object newValue)  
//		{
//			if(newValue.GetType() != Type.GetType("CSharpSample.Person"))
//				throw new ArgumentException("newValue must be of type CSharpSample.Person.", "newValue");
//		}
//
//		protected override void OnValidate(Object value)  
//		{
//			if(value.GetType() != Type.GetType("CSharpSample.Person"))
//				throw new ArgumentException("value must be of type CSharpSample.Person.");
//		}

		#endregion
	}

	[Serializable]
	public class SpecialPerson : Person
	{
		public string Comment = "";
	}

	[Serializable]
	public class IAjaxObjectSource
	{
		public string Title = "";
		public string Filename = "";

		public IAjaxObjectSource(string title, string filename)
		{
			Title = title;
			Filename = filename;
		}
	}
}
