<%@ Page language="VJ#" Codebehind="default.aspx.jsl" AutoEventWireup="false" Inherits="JSharpSample._default" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<title>Ajax.NET - The free library for .NET (J#)</title>
		<script language="javascript" src="default.js"></script>
		<style type="text/css">
@import "main.css";
		</style>
	</head>
	<body>
	
		<form id="Form1" method="post" runat="server">
		
			<h1>Ajax.NET - A free library for the Microsoft .NET Framework</h1>
			<h3>Asynchronous JavaScript with XmlHttpRequest - J# Example</h3>
		
			<p><a href="http://ajax.schwarz-interactive.de/download/ajax.zip">Download</a> the latest Ajax.dll (5.6.3.4) to use it for free in your web projects.</p>
			
			<p>To learn more about <b>AJAX</b>, visit:<br>
			<a href="http://en.wikipedia.org/wiki/AJAX">http://en.wikipedia.org/wiki/AJAX</a><br>
			<a href="http://www.adaptivepath.com/publications/essays/archives/000385.php">http://www.adaptivepath.com/publications/essays/archives/000385.php</a>
			</p>
			
			<p>Visit my blog at <a href="http://weblogs.asp.net/mschwarz/">http://weblogs.asp.net/mschwarz/</a>.</p>
			
			<p>Download this C# example at <a href="http://ajax.schwarz-interactive.de/download/AjaxSample.zip">http://ajax.schwarz-interactive.de/download/AjaxSample.zip</a>.<br>
			Switch to the VB.NET example: <a href="http://ajax.schwarz-interactive.de/vbnetsample/default.aspx">http://ajax.schwarz-interactive.de/vbnetsample/default.aspx</a>.</p>
			
			<p>There is a usage guide (will be updated in the next days) available for the first version of the free Ajax.NET:<br>
			<a href="http://ajax.schwarz-interactive.de/download/AjaxGuide.doc">http://ajax.schwarz-interactive.de/download/AjaxGuide.doc</a><br>
			<a href="http://ajax.schwarz-interactive.de/download/quickGuide.txt">http://ajax.schwarz-interactive.de/download/quickGuide.txt</a> (Quick Guide)</p>
			
			<p>Use my contact form at <a href="http://weblogs.asp.net/mschwarz/contact.aspx">http://weblogs.asp.net/mschwarz/contact.aspx</a> to give feedback, ideas and if you got any error.</p>
			
			<p><br><br></p>
			
			<hr size="1"/>

			<h1>Examples using the free Ajax.NET library</h1>			
		
			<h3>Send feedback form with Unicode chars</h3>
			
			<p>This example will post a form to the server, invoke the Test1 method there and return a HTML string.</p>
			
			<p>On the server you will have a typical method with an additional attribute:</p>
			
			<pre>[Ajax.AjaxMethod]
public string Test1(string firstName, string familyName, string email, string comment)
{
  string html = "";
	
  html += "Hello " + firstName + " " + familyName + "&lt;br&gt;";
  html += "Thank you for your comment &lt;b&gt;";
  html += System.Web.HttpUtility.HtmlEncode(comment);
  html += "&lt;/b&gt;.";
	
  return html;
}</pre>
		
			<table>
			<tr><td>FirstName: </td><td><input type="text" id="firstName" value="Michael"></td></tr>
			<tr><td>FamilyName: </td><td><input type="text" id="familyName" value=""></td></tr>
			<tr><td>Email: </td><td><input type="text" id="email" value="info@yourcompany.com"></td></tr>
			<tr><td valign="top">My Comment:</td><td><textarea id="comment">??2.0??</textarea></td></tr>
			<tr><td> </td><td><a href="javascript:test1();void(0);">Submit</a><br></td></tr>
			<tr><td> </td><td><span id="display1" style="font-family:courier;">&nbsp;</span></td></tr>
			</table>
			
			<hr size="1"/>
			
			<h3>Send a custom type as argument</h3>
			
			<p>The second sample will show you how to pass a real .NET object as an argument for your method. The Test2 method will have a System.DateTime argument. The IAjaxObjectConverter will give you a simple to use client script to create the wrapper for .NET. On the client script you can use following script to create such an object:</p>
			
			<pre>var d = new DateTime(2005, 4, 20, 0, 0, 0);	// April 20th 2005</pre>

			<p>To call the AJAX.NET method you will write:</p>
			
			<pre>DemoMethods.Test2(d, callback);</pre>
			
			<p>The AJAX.NET wrapper on the server will check which converter can decode the Javascript object and passes the method a correct object. You can create your own IAjaxObjectConverters to allow every object to be returned or accepted.</p>
			
			<pre>[Ajax.AjaxMethod]
public string Test2(DateTime d)
{
  d = d.AddDays(1);
  return "The next day will be " + d.ToLongDateString() + ".";
}</pre>
			
			<table>
			<tr><td>DateTime (YYYY.MM.DD):</td><td>
				<input type="text" id="year" value="2005" size="2">
				<input type="text" id="month" value="4" size="2">
				<input type="text" id="day" value="25" size="2">
			</td></tr>
			<tr><td> </td><td><a href="javascript:test2();void(0);">Submit</a><br></td></tr>
			<tr><td> </td><td><span id="display2" style="font-family:courier;">&nbsp;</span></td></tr>
			</table>
			
			<p>Currently I have following IAjaxObjectConverters:<br>
			- System.Collections.ArrayList<br>
			- System.Data.DataSet/DataTable/DataRow<br>
			- System.DateTime/TimeSpan<br>
			- System.Array</p>
			
			<hr size="1"/>
			
			<h3>Use a System.Data.DataSet to fill a drop down box</h3>
			
			<p>Because you can return any object it is possible to fill a drop down box with only two lines. The list of countries will be fetched from the server after you have clicked on the link.</p>
			
			<pre>function callback(res)
{
  var html = [];
	
  for(var i=0; i&lt;res.value.Tables[0].Rows.length; i++)
    html[html.length] = "&lt;option&gt;" + res.value.Tables[0].Rows[0].Country + "&lt;/option&gt";
		
  document.getElementById("display").innerHTML = "&lt;select id=\"sel\"&gt;" + html.join("") + "&lt;/select&gt";
}</pre>
			
			<table>
			<tr><td valign="top">Country: </td><td><span id="display3"><a href="javascript:test3();void(0);">Click here to load contry list...</a></span><br><br></td></tr>
			</table>
			
			
			<hr size="1"/>

			<h3>Exception handling with Ajax.NET</h3>			

			<p>The next example will throw a security exception on the server (System.Security.SecurityException). The callback handler will check if the error property is filled an will show the exception.</p>
			
			<pre>function callback(res)
{
  if(res.error != null)
    alert(res.error);
}</pre>
			
			<p><a href="javascript:test4();void(0);">Click here to throw an exception on the server.</a></p>
			
			
			<hr size="1"/>
			
			<h3>Session State handling with Ajax.NET</h3>
			
			<p>A lot of developers asked for the session station access. Now, we you can access your session variables.</p>
			<p>First click on <i>write</i> to save the value i.e. "demo" to the session on the server. Now, you can press F5 (reload) and click on <i>read</i>. You should see the same value as you have written to the session state.</p>
			<table>
			<tr><td>Session Handling Demo</td></tr>
			<tr><td>Write value</td><td><input type="text" id="sessionTest1" value="demo"></td><td><a href="javascript:test5();void(0);">Write</a></td></tr>
			<tr><td>Read value</td><td><input type="text" id="sessionTest2" value=""></td><td><a href="javascript:test6();void(0);">Read</a></td></tr>
			</table>

			<p>On the server the C# method looks like following code:</p>
			
			<pre>[Ajax.AjaxMethod(HttpSessionStateRequirement.ReadWrite)]
public void Test5(string value)
{
  System.Web.HttpContext.Current.Session["example"] = value;
}

[Ajax.AjaxMethod(HttpSessionStateRequirement.Read)]
public string Test6()
{
  if(System.Web.HttpContext.Current.Session["example"] != null)
    return (string)System.Web.HttpContext.Current.Session["test"];

  return "First set the value...";
}</pre>

			<hr size="1"/>
			
			<h3>Is it possible to wait for events?</h3>
			
			<p>Yes, you can use System.Threading.Thread to wait for events instead of pooling every second. Because the server process does not get informed when a client browser has been closed you should not use a infinite loop.</p>
			<p>Why to use a loop at the server instead of polling every second? You will save client requests to the server that will use the Internet bandwidth and will create a new request on the server. So, you will have 10 requests if you will poll and one request if you loop at the server for 10 seconds!</p>
			
			<p>Click <a href="javascript:test7();void(0)">here</a> to start the process at the server. There is no timer at the client's javascript. In 10 seconds the request will response and call the client callback function which will show a alert box. There will be no network traffic until the method returns. Click on the link two times and you will get two alert boxes!</p>
			<p><i>Note:</i> You can have simultaneous requests at the same time, there are no restrictions.</p>	
			
			<pre>[Ajax.AjaxMethod]
public void Test7()
{
  int c = 0;

  do
  {
    System.Threading.Thread.Sleep(1000);
    c++;
  }
  while(c < 10);
}</pre>
			
			<hr size="1"/>
			
			<h3>Using a context on the client-side Javascript</h3>
			
			<p>If I want to update several elements (i.e. DIV) on the screen I had to use different callback functions in the last release. Now, you can add a context that is accessable in the callback function.</p>
			<p>The following sample will update the element you clicked on. There is only one Javascript function that will handle the callback:</p>
			
			<pre>&lt;script language="javascript"&gt;
function test8(ele)
{
	DemoMethods.Test8(test8_callback, ele);  // the server-side method has no arguments!
}

function test8(res)
{
	if(res.error == null && res.context != null)
		res.context.innerHTML = res.value;
}
&lt;/script&gt;

&lt;span onclick="test8(this);"&gt;Element1&lt;/span&gt;
&lt;span onclick="test8(this);"&gt;Element2&lt;/span&gt;

</pre>

			<p>DIV elements: 
				<span style="cursor:hand;color:red;text-decoration:underline;" onclick="test8(this);">Click here</span>
				<span style="cursor:hand;color:blue;text-decoration:underline;" onclick="test8(this);">Click here</span>
				<span style="cursor:hand;colod:green;text-decoration:underline;" onclick="test8(this);">Click here</span>
			</p>
			
			
			<hr size="1"/>
			
			
			
			
			
			<p><br><br><br><br><br><br><br></p>
			
			
		</form>
		
	</body>
</HTML>
